; ***********************************************
; *     B.P.B. vr_trnfm()-Fix 1.8               *
; * Behebt den int-overflow-Fehler in der       *
; * vr_trnfm() - Routine des TOS.               *
; *                                             *
; * Geschrieben von L. Prner                  *
; * S. und W. Behne im Mai/Juli 1991            *
; *                                             *
; * Die schnelle vr_trnfm() - Funktion          *
; * entstammt dem Screenspeeder NVDI.           *
; *                                             *
; * Sprache : 680x0-Assembler                   *
; * Compiler: TurboAss 1.76                     *
; ***********************************************

; Konstantendeklaration:

fd_h	EQU	$06
fd_wdwidth	EQU	$08
fd_stand	EQU	$0A
fd_nplanes	EQU	$0C
s_addr	EQU	$0E

xbra_id	EQU	'Tpat'	; XBRA-Kennung
nvdi_cookie	EQU	'NVDI'

vr_t_code	EQU	$69	; Kennung der vr_trnfm()-Funktion
vdi	EQU	$73	; Trap #2-Kennung fr VDI-Aufrufe
vdi_trap	EQU	$88	; Adresse den #2-Traps
_p_cookies	EQU	$05A0	; Cookie-Kontrolle

TEXT

; Programmbeginn:

anfang:
	bra	main

; Hier wird spter die Durchsprungedresse zwischengespeichert!

; ***********************************
; * Neuer vq_driver() - Dispatcher  *
; ***********************************

vq_d_dis:
	move.l	A2, -(SP)	; Register A2 retten

	movea.l	D1, A2	; -> PB in A2
	movea.l	(A2)' A2	: -> Control in A2
	cmpi.w	#vr_t_code, (A2)	; vr_trnfm()-Aufruf?
	beq	tpatch	; Wenn ja -> Patchroutine

; Nach dem &quot;rts&quot; in der Patchroutine springt der PC wieder zurck zum
; aufrufenden Programm

	movea.l	(SP)+, A2	; Nein -> Register wieder herstellen
	move.l	anfang(PC), -(SP)	; anschl. Sprung zum vorherigen
	rts		; vq_driver-Dispatcher

; ***********************************
; * Neuer VDI - Dispatcher          *
; ***********************************

; Vorsichtshalber werden alle benutzten Register gerettet.

	DC.L	'XBRA'
	DC.L	xbra_id
old_vdi_trap:
	DS.L	1

new_vdi_trap:
	cmp.w	#vdi, D0	; VDI-Aufruf?
	bne.s	vq_driver	; Nein -> vielleicht vq_driver-Aufruf?
	bsr.s	xbra_chain_dis
	rte		; Zurck zum aufrufenden Prozess

vq_driver:
	cmp.w	#-1, D0	; vq_driver()-Aufruf?
	beq.s	vq_driver_fnd	; Ja -> eigenen Dispatcher zurckl.

	move.l	old_vdi_trap(PC), -(SP)
	rts		; Nein -> ber alten XBRA-Vektor spr.

vq_driver_fnd:
	move.l	#vq_d_dis, D0	; Dispatcher vq_driver
	rte		; Zurck zum aufrufenden Prozess

xbra_chain_dis:
	move.l	A2, -(SP)	; Register A2 retten

	movea.l	D1, A2	; -> PB in A2
	movea.l	(A2), A2	; -> Control in A2
	cmpi.w	#vr_t_code, (A2)	; vr_trnfm()-Aufruf?
	beq.s	vrt_patch	; Wenn ja -> Patchroutine

; Nach dem &quot;rte&quot; in der Patchroutine springt der PC wieder in new_vdi_trap

	movea.l	(SP)+, A2	; Nein -> Register wiederherstellen

	move.l	old_vdi_trap(PC), (SP)	; Und per XBRA-Kette weiter
	rte

; Kein '-(SP)', da eine Rcksprungadresse berschrieben werden mu!

; ************************************
; * Hier der eigentliche Fix         *
; ************************************

vr_t_patch:
	movem.l	D0-D4/D7-A1, -(SP)	; Weitere benutzte Register retten
	bsr.s	vr_trnfm	;  transformieren
	movem.l	(sp)+, D0-D4/D7-A2	; Register alle wiederherstellen

; Man beachte: A2 wird hier eingelesen, weil es in new_vdi_trap gerettet wurde.

rts

; ************************************
; * Die vr_trnfm()-Routine aus NVDI. *
; ************************************

vr_trnfm:
	movem.l	s_addr(A2), A0-A1	; Zeiger auf psrcMFDB/pdesMFDB
	moveq	#0, D0	; Langwort lschen
	move.w	fd_nplanes(A0), D0	; Anzahl der Quellebenen
	move.w	fd_h(A0), D1	; Anzahl der Quellzeilen
	mulu	fd_wdwidth(A0), D1	; Wortanzahl d. Quellbl. pro Ebene
	tst.w	fd_stand(A0)	; gerteabhngiges Quellformat
	bne.s	vr_trnfm_dep
	move.w	#1, fd_stand(A1)	; standardisiertes Zielformat
	bra.s	vr_trnfm_addr

vr_trnfm_dep:
	clr.w	fd_stand(A1)	; gerteabhngiges Zielformat
	exg	D0, D1	; Planes und Worte tauschen

vr_trnfm_addr:
	movea.l	(A0), A0	; Quellblockadresse
	movea.l	(A1), A1	; Zielblockadresse
	subq.l	#1, D0	; Mindestens eine Ebene/Wort?
	bmi.s	vr_trnfm_exit
	move.l	D1, D4
	subq.l	#1, D4	; Wort-/Ebenenzhler
	bmi.s	vr_trnfm_exit
	cmpa.l	A0, A1	; Ziel- und Quelldresse gleich?
	beq.s	vr_trnfm_same

	add.l	D1, D1	; Abstand zum nchsten Wort/Ebene

; Qell- und Zieladresse sind verschieden

vr_trnfm_diff:
	movea.l	A1, A2
	move.l	D0, D3
vr_trnfm_d_copy:
	move.w	(A0)+, (A2)
	adda.l	D1, A2	; nchstes Zielwort
	subq.l	#1, D3
	bpl.s	vr_trnfm_d_copy
	addq.l	#2, A1	; nchste Ebene
	subq.l	#1, D4
	bpl.s	vr_trnfm_diff
	rts

; Quell- und Zieladresse sind gleich

vr_trnfm_same:
	subq.l	#1, D4	; nur eine Ebene/Wort?
	bmi.s	vr_trnfm_exit

vr_trnfm_s_loop:
	moveq	#0, D2
	move.l	D4, D1	; Wort-/Ebenenzhler

vr_trnfm_bls:
	adda.l	D0, A0
	lea	2(A0, D0.l), A0
	move.w	(A0), D5
	movea.l	A0, A1
	movea.l	A0, A2
	add.l	D0, D2
	move.l	D2, D3
	bra.s	vr_trnfm_s_next

vr_trnfm_copy:
	movea.l	A1, A2
	move.l	-(A1), (A2)	; alles um ein Wort verschieben

vr_trnfm_s_next:
	subq.l	#1, D3
	bpl.s	vr_trnfm_s_copy
	move.w	D5, (A1)

vr_trnfm_dbfs:
	subq.l	#1, D1
	blpl.s	vr_trnfm_bls
	movea.l	A2, A0
	subq.l	#1, D0
	bpl.s	vr_trnfm_s_loop

vr_trnfm_exit:
	rts

; Der folgende Code bleibt nicht resident

endcode:

; ********************************************************
; * Hauptprogramm fr Installation und Einschaltmeldung  *
; ********************************************************

main:
	moveq	#-2, D0	; vq_gdos()
	trap	#2
	addq.w	#2, D0
	beq.s	cont_test
	pea	vor_gdos(PC)	; Warnung, falls GDOS schon
	move.w	#9, -(SP)	; aktiv ist.
	trap	#1
	addq.l	#6, SP

cont_test:
	moveq	#-1, D0	; vq_driver()
	trap	#2
	move.l	D0, anfang	; alter VDI-Dispatcher

	pea	vdi_install(PC)	; XBRA-Installation im
	move.w	#$26, -(SP)	; Supervisormodus durchfhren
	trap	#14	; Supexec()
	addq.l	#6, SP

	clr.w	-(SP)	; Entscheidung Ptem0/Ptermres()
	tst.w	D0	; resident halten / lschen
	bne.s	abgang
	pea	$100 + endcode - anfang.w	; Basepage + residenter Code

	move.w	#$31, -(SP)
	pea	instmeld(PC)	; Istallationsmeldung ausgeben
	move.w	#9, - (sp)
	trap	#1
	addq.l	#6, SP

abgang:
	trap	#1

; ****************************************
; * Probe, ob NVDI schon installiert ist *
; ****************************************

vdi_install:
	move.l	_p_cookies.w. D0
	beq.s	x_inst
	movea.l	D0, A0

find_cookie:
	move.l	(A0), D0
	beq.s	x_inst
	addq.l	#8, A0
	cmpi.l	#nvdi_cookie, D0
	bne.s	find_cookie

; NVDI schon vorhanden! Falsche Reihenfolge im AUTO-Ordner!

	pea	wrong_order(PC)
	move.w	#9, -(SP)
	trap	#1
	addq.l	#6, SP

	moveq	#1, D0
	rts

; ********************************************** 
; * XBRA-Installationsroutine fr den VDI-Trap *
; **********************************************

x_inst:
	lea	vdi_trap.w, A0
	lea	new_vdi_trap(PC), A1
	move.l	A0, D0

kette:
	movea.l	(A0), A2
	cmpi.l	#'XBRA', -12(A2)	; XBRA-Struktur gefunden?
	bne.s	install	; Wenn nicht, dann installieren
	move.l	-8(A1), D1	; ist es die gleiche Routine?
	cmp.l	-(A2), D1
	beq.s	found	; Ja!
	lea	-4(A2), A0
	bra.s	kette

install:
	movea.l	D0, A0	; Routine installieren
	move.l	(A0), -4(A0)
	move.l	A1, (A0)

	moveq	#0, D0	; Installiert
	rts

found:
	st	D0	; Installation nicht durchgefhrt
	rts

DATA

; *********************
; * User-Mitteilungen *
; *********************

instmeld:
	DC.B	$0A, $0D
	DC.B	'vr_trnfm()-fix 1.8 by Laurenz Prner,'
	DC.B	$0A, $0D
	DC.B	'Sven and Wilfried Behne Installed.'
	DC.B	$0A, $0D
	DC.B	$BD, ' Cynics 1991.'
	DC.B	$0A, $0D, 0
	EVEN

wrong_order:
	DC.B	7, $0A, $0D
	DC.B	'Wrong order in your AUTO-folder!!'
	DC.B	$0A, $0D
	DC.B	'vr_trnfm()-fix must be installed'
	DC.B	$0A $0D
	DC.B	'before NVDI.'
	DC.B	$0A, $0D $0A, $0D, 0
	EVEN

vor_gdos:
	DC.B	7, $0A, $0D
	DC.B	'Wrong order in your AUTO-folder!'
	DC.B	$0A, $0D
	DC.B	'vr_trnfm()-fix should be installed'
	DC.B	$0A, $0D
	DC.B	'before GDOS.'
	DC.B	$0A, $0D, $0A, $0D, 0

END
